#include <stdio.h>
#include <mpi.h>

#define SANE_PROC(rank, size)			\
  ((rank) < 0 || (rank) >= (size) ?		\
   MPI_PROC_NULL : (rank))

#define SYNCH_TAG 42

int main (int argc, char * argv[]) {
  int mpi_rank = -1;
  int mpi_size = 0;

  int synch = 0;

  MPI_Init(&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &mpi_rank);
  MPI_Comm_size(MPI_COMM_WORLD, &mpi_size);

  MPI_Recv(&synch, 1, MPI_INT,
	   SANE_PROC(mpi_rank-1, mpi_size),
	   SYNCH_TAG, MPI_COMM_WORLD,
	   MPI_STATUS_IGNORE);

  printf("I am process %d out of %d processes!\n",
	 mpi_rank, mpi_size);
  fflush(stdout);

  MPI_Send(&synch, 1, MPI_INT,
	   SANE_PROC(mpi_rank+1, mpi_size),
	   SYNCH_TAG, MPI_COMM_WORLD);

  MPI_Finalize();
  return 0;
}
